/*
 *      @(#)Copyright (c) 1994, Simon J. Gerraty.
 *      
 *      This code is presented AS IS.  It comes with NO WARRANTY.
 *      Permission to use, modify and distribute this source code 
 *      is granted subject to the following conditions.
 *      1/ that the above copyright notice and this notice 
 *      are preserved in all copies and that due credit be given 
 *      to the author.  
 *      2/ that any changes to this code are clearly commented 
 *      as such so that the author does not get blamed for bugs 
 *      other than his own.
 *      
 *      Please send copies of changes and bug-fixes to:
 *      sjg@zen.void.oz.au
 */
#ifndef lint
static char RCSid[] = "$Id: authclnt.c,v 1.1 1995/02/08 11:50:12 sjg Exp $";
#endif
#include <stdio.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <signal.h>
#include <errno.h>
#ifdef HAVE_SYS_SELECT_H
#include <sys/select.h>
#endif

#ifndef O_RDWR
# define O_RDWR 2
#endif

int
get_auth(s)
	int s;
{
	fd_set rfds;
	char	abuf[128], ubuf[128];
	int tty = 0;				/* stdin */
	int authorized = 0;
	int n;
	
	if (!isatty(0))
		tty = open("/dev/tty", O_RDWR);

	if (tty < 0)
		return 0;			/* failed */

	while (!authorized) {
		FD_ZERO(&rfds);
		FD_SET(s, &rfds);
		FD_SET(tty, &rfds);

		if (select(20, &rfds, NULL, NULL, NULL) < 0) {
			if (errno == EINTR)
				continue;
			return 0;
		}
		if (FD_ISSET(s, &rfds)) {
			if ((n = read(s, abuf, sizeof(abuf))) <= 0) {
				warnx("read");
				exit(1);
			}
			if (strncmp(abuf, "Ok", 2) == 0) {
				authorized++;
				write(1, abuf, n);
				break;
			} else if (strncmp(abuf, "Passw", 5) == 0) {
				extern char *getpass();
			
				strcpy(ubuf, getpass(abuf));
				write(s, ubuf, strlen(ubuf));
				continue;
			}
			write(1, abuf, n);
		}
		if (FD_ISSET(tty, &rfds)) {
			ubuf[0] = '\0';
			if ((n = read(tty, ubuf, sizeof(ubuf))) > 0)
				write(s, ubuf, n);
		}
	}
	if (tty > 0)
		close(tty);
	return authorized;
}
