/*
 *      @(#)Copyright (c) 1994, Simon J. Gerraty.
 *      
 *      This code is presented AS IS.  It comes with NO WARRANTY.
 *      Permission to use, modify and distribute this source code 
 *      is granted subject to the following conditions.
 *      1/ that the above copyright notice and this notice 
 *      are preserved in all copies and that due credit be given 
 *      to the author.  
 *      2/ that any changes to this code are clearly commented 
 *      as such so that the author does not get blamed for bugs 
 *      other than his own.
 *      
 *      Please send copies of changes and bug-fixes to:
 *      sjg@zen.void.oz.au
 */
#ifndef lint
static char RCSid[] = "$Id: doauth.c,v 1.2 1995/02/13 09:04:02 sjg Exp $";
#endif
#include <stdio.h>
#include <syslog.h>

#ifdef NO_FWTK
int
do_auth(s, progname)
	int s;
	char *progname;
{
	return 0;				/* problem */
}
#else
#include "firewall.h"				/* TIS fwtk */

/*
 *	This should have been in the TIS toolkit, it is almost
 *	straight out of the auth(3) man page.
 *
 *	Get username and do challenge/response with user
 *	Succeed or die.
 */

static int
say(s, msg)
	int s;
	char *msg;
{
	char buf[256];

	sprintf(buf, "%s\n", msg);
	return write(s, buf, strlen(buf));
}

int
do_auth(s, progname)
	int s;					/* socket */
	char *progname;				/* who requires auth? */
{
	static char	prompt[] = "Username: ";
	static char	pwprompt[] = "Password: ";
	Cfg		*confp;
	char		cbuf[128];
	char		ubuf[128], buf[128];
	int		n, bad = 5;

	if ((confp = cfg_read(progname)) == (Cfg *)-1)
		exit(1);
	
	auth_open(confp);

	/* get welcome message from auth server */
	if (auth_recv(buf,sizeof(buf))) {
		exit(1);
	}
	if(strncmp(buf,"Authsrv ready",13)) {
		auth_close();
		exit(1);
	}

	while(bad--) {
		write(s, prompt, sizeof(prompt));
		if ((n = get_line(s, ubuf,sizeof(ubuf))) < 0) {
			syslog(LOG_ERR, "lost connection");
			exit(0);
		} else if (n == 0) {
			/* blank doesn't count against bad */
			bad++;
			continue;
		}
		sprintf(cbuf,"authorize %s %s",ubuf, progname);
		auth_send(cbuf);
		auth_recv(cbuf,sizeof(cbuf));

		if (strncmp(cbuf,"challenge ",10) == 0) {
			write(s, &cbuf[10], strlen(&cbuf[10]));
		} else if (strncmp(cbuf,"password",8) == 0) {
			write(s, pwprompt, sizeof(pwprompt));
		} else {
			say(s, cbuf);
			continue;
		}
		get_line(s, ubuf, sizeof(ubuf));
		sprintf(cbuf,"response '%s'",ubuf);
		auth_send(cbuf);
		auth_recv(cbuf,sizeof(cbuf));

		if (strncmp(cbuf,"ok",2) != 0) {
			say(s, cbuf);
			continue;
		}
		auth_close();
		cbuf[0] = 'O';			/* Ok */
		cbuf[1] = 'k';
		say(s, cbuf);
		return 1;
	}
	auth_close();
	return 0;
}
#endif
