/*
 *      @(#)Copyright (c) 1993, Simon J. Gerraty.
 *      
 *      This code is presented AS IS.  It comes with NO WARRANTY.
 *      Permission to use, modify and distribute this source code 
 *      is granted subject to the following conditions.
 *      1/ that the above copyright notice and this notice 
 *      are preserved in all copies and that due credit be given 
 *      to the author.  
 *      2/ that any changes to this code are clearly commented 
 *      as such so that the author does not get blamed for bugs 
 *      other than his own.
 *      
 *      Please send copies of changes and bug-fixes to:
 *      sjg@zen.void.oz.au
 */

#ifndef lint
static char RCSid[] = "$Id: ipcallid.c,v 1.4 1995/03/28 22:30:36 sjg Exp $";
#endif
#include <stdio.h>
#ifdef __STDC__
#include <stdlib.h>
#endif
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <string.h>
#include <fcntl.h>
#include <ctype.h>
#include <errno.h>
#include <signal.h>
#include <syslog.h>

#ifndef MAXNAMLEN
# define MAXNAMLEN 256
#endif

extern int errno;

char *
ip_caller_id(sa, lookup)
	struct sockaddr_in *sa;
	int	lookup;
{
	static char	*name, caller_id[MAXNAMLEN];
        struct hostent	*hp = NULL;
	struct servent	*sp = NULL;
	struct in_addr	in;
	register char	*rcp;
	int		port = ntohs(sa->sin_port);
	
	name = inet_ntoa(sa->sin_addr);
	if (lookup &&
	    (hp = gethostbyaddr((char *) &sa->sin_addr,
				sizeof(sa->sin_addr), AF_INET)) != NULL) 
		name = hp->h_name;
	(void) sprintf(caller_id, "%s.", name);
	rcp = strchr(caller_id, '\0');
	if (lookup && (port == 0 || 
		       (sp = getservbyport((int) sa->sin_port, (char *) NULL))))
		(void) sprintf(rcp, "%s", sp ? sp->s_name : "*");
	else
		(void) sprintf(rcp, "%d", port);

	return caller_id;
}

char *
sock_id(s, flags)
	int s;
	int flags;
{
	struct sockaddr_in sa;
	int i = -1;
	int x;

	x = sizeof (sa);
	if (flags & 2) {			/* peer */
		i = getpeername(s, (struct sockaddr *)&sa, &x);
	} else {
		i = getsockname(s, (struct sockaddr *)&sa, &x);
	}
	if (i >= 0)
		return ip_caller_id(&sa, (flags & 1));
	return (char *) 0;
}

